module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 26);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("react-fela");

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("react-redux");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("redux");

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var IconPanel_1 = __webpack_require__(21);
exports.IconPanel = IconPanel_1.default;
var TreePanel_1 = __webpack_require__(22);
exports.TreePanel = TreePanel_1.default;
var EditorPanel_1 = __webpack_require__(19);
exports.EditorPanel = EditorPanel_1.default;
var ConsolePanel_1 = __webpack_require__(18);
exports.ConsolePanel = ConsolePanel_1.default;


/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/client-layout-redux");

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(2);
exports.withTheme = keyValue => {
    const storeKeys = Object.keys(keyValue);
    const mapStateToProps = state => {
        const theme = state.theme;
        return storeKeys.reduce((acc, cur) => {
            acc[keyValue[cur]] = theme[cur];
            return acc;
        }, {});
    };
    return react_redux_1.connect(mapStateToProps);
};


/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const redux_1 = __webpack_require__(3);
const react_redux_1 = __webpack_require__(2);
const client_layout_redux_1 = __webpack_require__(5);
const components_1 = __webpack_require__(4);
const hoc_1 = __webpack_require__(6);
const ConsolePanelComponent = (props) => (React.createElement(components_1.ConsolePanel, Object.assign({}, props)));
const openPrev = (dispatch, getState) => {
    const { resize: rsz } = getState();
    if (!rsz.consolePanelPrev || rsz.consolePanelPrev > window.innerHeight * 0.9) {
        dispatch(client_layout_redux_1.resize('consolePanel', Math.min(300, window.innerHeight * 0.8)));
    }
    dispatch(client_layout_redux_1.resize('consolePanel', rsz.consolePanelPrev));
};
const themed = redux_1.compose(...[
    hoc_1.withTheme({
        backgroundBlue: 'backgroundColor',
    }),
    react_redux_1.connect(state => ({ height: state.resize.consolePanel }), dispatch => ({
        onResize: ({ height }) => dispatch(client_layout_redux_1.resize('consolePanel', height)),
        saveSize: ({ height }) => dispatch(client_layout_redux_1.resize('consolePanelPrev', height)),
        open: () => dispatch(openPrev),
    })),
])(ConsolePanelComponent);
exports.default = themed;


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const redux_1 = __webpack_require__(3);
const react_redux_1 = __webpack_require__(2);
const components_1 = __webpack_require__(4);
const hoc_1 = __webpack_require__(6);
const EditorPanelEnhanced = redux_1.compose(hoc_1.withTheme({
    backgroundBlue: 'backgroundColor',
}), react_redux_1.connect(state => ({
    treePanelWidth: state.resize.treePanel,
})))(components_1.EditorPanel);
exports.default = EditorPanelEnhanced;


/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var TreePanel_1 = __webpack_require__(25);
exports.TreePanelEnhanced = TreePanel_1.default;
var EditorPanel_1 = __webpack_require__(8);
exports.EditorPanelEnhanced = EditorPanel_1.default;
var ConsolePanel_1 = __webpack_require__(7);
exports.ConsolePanelEnhanced = ConsolePanel_1.default;
var IconPanel_1 = __webpack_require__(23);
exports.IconPanelEnhanced = IconPanel_1.default;
var RightLayout_1 = __webpack_require__(24);
exports.RightLayout = RightLayout_1.default;


/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(11)(undefined);
// imports


// module
exports.push([module.i, ".react-resizable {\n  position: relative;\n}\n.react-resizable-handle {\n  position: absolute;\n  width: 20px;\n  height: 100%;\n  right: 0;\n  padding: 0 3px 3px 0;\n  box-sizing: border-box;\n  cursor: col-resize;\n}\n", ""]);

// exports


/***/ }),
/* 11 */
/***/ (function(module, exports) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/
// css base code, injected by the css-loader
module.exports = function(useSourceMap) {
	var list = [];

	// return the list of modules as css string
	list.toString = function toString() {
		return this.map(function (item) {
			var content = cssWithMappingToString(item, useSourceMap);
			if(item[2]) {
				return "@media " + item[2] + "{" + content + "}";
			} else {
				return content;
			}
		}).join("");
	};

	// import a list of modules into the list
	list.i = function(modules, mediaQuery) {
		if(typeof modules === "string")
			modules = [[null, modules, ""]];
		var alreadyImportedModules = {};
		for(var i = 0; i < this.length; i++) {
			var id = this[i][0];
			if(typeof id === "number")
				alreadyImportedModules[id] = true;
		}
		for(i = 0; i < modules.length; i++) {
			var item = modules[i];
			// skip already imported module
			// this implementation is not 100% perfect for weird media query combinations
			//  when a module is imported multiple times with different media queries.
			//  I hope this will never occur (Hey this way we have smaller bundles)
			if(typeof item[0] !== "number" || !alreadyImportedModules[item[0]]) {
				if(mediaQuery && !item[2]) {
					item[2] = mediaQuery;
				} else if(mediaQuery) {
					item[2] = "(" + item[2] + ") and (" + mediaQuery + ")";
				}
				list.push(item);
			}
		}
	};
	return list;
};

function cssWithMappingToString(item, useSourceMap) {
	var content = item[1] || '';
	var cssMapping = item[3];
	if (!cssMapping) {
		return content;
	}

	if (useSourceMap && typeof btoa === 'function') {
		var sourceMapping = toComment(cssMapping);
		var sourceURLs = cssMapping.sources.map(function (source) {
			return '/*# sourceURL=' + cssMapping.sourceRoot + source + ' */'
		});

		return [content].concat(sourceURLs).concat([sourceMapping]).join('\n');
	}

	return [content].join('\n');
}

// Adapted from convert-source-map (MIT)
function toComment(sourceMap) {
	// eslint-disable-next-line no-undef
	var base64 = btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap))));
	var data = 'sourceMappingURL=data:application/json;charset=utf-8;base64,' + base64;

	return '/*# ' + data + ' */';
}


/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/
var stylesInDom = {},
	memoize = function(fn) {
		var memo;
		return function () {
			if (typeof memo === "undefined") memo = fn.apply(this, arguments);
			return memo;
		};
	},
	isOldIE = memoize(function() {
		// Test for IE <= 9 as proposed by Browserhacks
		// @see http://browserhacks.com/#hack-e71d8692f65334173fee715c222cb805
		// Tests for existence of standard globals is to allow style-loader 
		// to operate correctly into non-standard environments
		// @see https://github.com/webpack-contrib/style-loader/issues/177
		return window && document && document.all && !window.atob;
	}),
	getElement = (function(fn) {
		var memo = {};
		return function(selector) {
			if (typeof memo[selector] === "undefined") {
				memo[selector] = fn.call(this, selector);
			}
			return memo[selector]
		};
	})(function (styleTarget) {
		return document.querySelector(styleTarget)
	}),
	singletonElement = null,
	singletonCounter = 0,
	styleElementsInsertedAtTop = [],
	fixUrls = __webpack_require__(13);

module.exports = function(list, options) {
	if(typeof DEBUG !== "undefined" && DEBUG) {
		if(typeof document !== "object") throw new Error("The style-loader cannot be used in a non-browser environment");
	}

	options = options || {};
	options.attrs = typeof options.attrs === "object" ? options.attrs : {};

	// Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
	// tags it will allow on a page
	if (typeof options.singleton === "undefined") options.singleton = isOldIE();

	// By default, add <style> tags to the <head> element
	if (typeof options.insertInto === "undefined") options.insertInto = "head";

	// By default, add <style> tags to the bottom of the target
	if (typeof options.insertAt === "undefined") options.insertAt = "bottom";

	var styles = listToStyles(list, options);
	addStylesToDom(styles, options);

	return function update(newList) {
		var mayRemove = [];
		for(var i = 0; i < styles.length; i++) {
			var item = styles[i];
			var domStyle = stylesInDom[item.id];
			domStyle.refs--;
			mayRemove.push(domStyle);
		}
		if(newList) {
			var newStyles = listToStyles(newList, options);
			addStylesToDom(newStyles, options);
		}
		for(var i = 0; i < mayRemove.length; i++) {
			var domStyle = mayRemove[i];
			if(domStyle.refs === 0) {
				for(var j = 0; j < domStyle.parts.length; j++)
					domStyle.parts[j]();
				delete stylesInDom[domStyle.id];
			}
		}
	};
};

function addStylesToDom(styles, options) {
	for(var i = 0; i < styles.length; i++) {
		var item = styles[i];
		var domStyle = stylesInDom[item.id];
		if(domStyle) {
			domStyle.refs++;
			for(var j = 0; j < domStyle.parts.length; j++) {
				domStyle.parts[j](item.parts[j]);
			}
			for(; j < item.parts.length; j++) {
				domStyle.parts.push(addStyle(item.parts[j], options));
			}
		} else {
			var parts = [];
			for(var j = 0; j < item.parts.length; j++) {
				parts.push(addStyle(item.parts[j], options));
			}
			stylesInDom[item.id] = {id: item.id, refs: 1, parts: parts};
		}
	}
}

function listToStyles(list, options) {
	var styles = [];
	var newStyles = {};
	for(var i = 0; i < list.length; i++) {
		var item = list[i];
		var id = options.base ? item[0] + options.base : item[0];
		var css = item[1];
		var media = item[2];
		var sourceMap = item[3];
		var part = {css: css, media: media, sourceMap: sourceMap};
		if(!newStyles[id])
			styles.push(newStyles[id] = {id: id, parts: [part]});
		else
			newStyles[id].parts.push(part);
	}
	return styles;
}

function insertStyleElement(options, styleElement) {
	var styleTarget = getElement(options.insertInto)
	if (!styleTarget) {
		throw new Error("Couldn't find a style target. This probably means that the value for the 'insertInto' parameter is invalid.");
	}
	var lastStyleElementInsertedAtTop = styleElementsInsertedAtTop[styleElementsInsertedAtTop.length - 1];
	if (options.insertAt === "top") {
		if(!lastStyleElementInsertedAtTop) {
			styleTarget.insertBefore(styleElement, styleTarget.firstChild);
		} else if(lastStyleElementInsertedAtTop.nextSibling) {
			styleTarget.insertBefore(styleElement, lastStyleElementInsertedAtTop.nextSibling);
		} else {
			styleTarget.appendChild(styleElement);
		}
		styleElementsInsertedAtTop.push(styleElement);
	} else if (options.insertAt === "bottom") {
		styleTarget.appendChild(styleElement);
	} else {
		throw new Error("Invalid value for parameter 'insertAt'. Must be 'top' or 'bottom'.");
	}
}

function removeStyleElement(styleElement) {
	styleElement.parentNode.removeChild(styleElement);
	var idx = styleElementsInsertedAtTop.indexOf(styleElement);
	if(idx >= 0) {
		styleElementsInsertedAtTop.splice(idx, 1);
	}
}

function createStyleElement(options) {
	var styleElement = document.createElement("style");
	options.attrs.type = "text/css";

	attachTagAttrs(styleElement, options.attrs);
	insertStyleElement(options, styleElement);
	return styleElement;
}

function createLinkElement(options) {
	var linkElement = document.createElement("link");
	options.attrs.type = "text/css";
	options.attrs.rel = "stylesheet";

	attachTagAttrs(linkElement, options.attrs);
	insertStyleElement(options, linkElement);
	return linkElement;
}

function attachTagAttrs(element, attrs) {
	Object.keys(attrs).forEach(function (key) {
		element.setAttribute(key, attrs[key]);
	});
}

function addStyle(obj, options) {
	var styleElement, update, remove, transformResult;

	// If a transform function was defined, run it on the css
	if (options.transform && obj.css) {
	    transformResult = options.transform(obj.css);
	    
	    if (transformResult) {
	    	// If transform returns a value, use that instead of the original css.
	    	// This allows running runtime transformations on the css.
	    	obj.css = transformResult;
	    } else {
	    	// If the transform function returns a falsy value, don't add this css. 
	    	// This allows conditional loading of css
	    	return function() {
	    		// noop
	    	};
	    }
	}

	if (options.singleton) {
		var styleIndex = singletonCounter++;
		styleElement = singletonElement || (singletonElement = createStyleElement(options));
		update = applyToSingletonTag.bind(null, styleElement, styleIndex, false);
		remove = applyToSingletonTag.bind(null, styleElement, styleIndex, true);
	} else if(obj.sourceMap &&
		typeof URL === "function" &&
		typeof URL.createObjectURL === "function" &&
		typeof URL.revokeObjectURL === "function" &&
		typeof Blob === "function" &&
		typeof btoa === "function") {
		styleElement = createLinkElement(options);
		update = updateLink.bind(null, styleElement, options);
		remove = function() {
			removeStyleElement(styleElement);
			if(styleElement.href)
				URL.revokeObjectURL(styleElement.href);
		};
	} else {
		styleElement = createStyleElement(options);
		update = applyToTag.bind(null, styleElement);
		remove = function() {
			removeStyleElement(styleElement);
		};
	}

	update(obj);

	return function updateStyle(newObj) {
		if(newObj) {
			if(newObj.css === obj.css && newObj.media === obj.media && newObj.sourceMap === obj.sourceMap)
				return;
			update(obj = newObj);
		} else {
			remove();
		}
	};
}

var replaceText = (function () {
	var textStore = [];

	return function (index, replacement) {
		textStore[index] = replacement;
		return textStore.filter(Boolean).join('\n');
	};
})();

function applyToSingletonTag(styleElement, index, remove, obj) {
	var css = remove ? "" : obj.css;

	if (styleElement.styleSheet) {
		styleElement.styleSheet.cssText = replaceText(index, css);
	} else {
		var cssNode = document.createTextNode(css);
		var childNodes = styleElement.childNodes;
		if (childNodes[index]) styleElement.removeChild(childNodes[index]);
		if (childNodes.length) {
			styleElement.insertBefore(cssNode, childNodes[index]);
		} else {
			styleElement.appendChild(cssNode);
		}
	}
}

function applyToTag(styleElement, obj) {
	var css = obj.css;
	var media = obj.media;

	if(media) {
		styleElement.setAttribute("media", media)
	}

	if(styleElement.styleSheet) {
		styleElement.styleSheet.cssText = css;
	} else {
		while(styleElement.firstChild) {
			styleElement.removeChild(styleElement.firstChild);
		}
		styleElement.appendChild(document.createTextNode(css));
	}
}

function updateLink(linkElement, options, obj) {
	var css = obj.css;
	var sourceMap = obj.sourceMap;

	/* If convertToAbsoluteUrls isn't defined, but sourcemaps are enabled
	and there is no publicPath defined then lets turn convertToAbsoluteUrls
	on by default.  Otherwise default to the convertToAbsoluteUrls option
	directly
	*/
	var autoFixUrls = options.convertToAbsoluteUrls === undefined && sourceMap;

	if (options.convertToAbsoluteUrls || autoFixUrls){
		css = fixUrls(css);
	}

	if(sourceMap) {
		// http://stackoverflow.com/a/26603875
		css += "\n/*# sourceMappingURL=data:application/json;base64," + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + " */";
	}

	var blob = new Blob([css], { type: "text/css" });

	var oldSrc = linkElement.href;

	linkElement.href = URL.createObjectURL(blob);

	if(oldSrc)
		URL.revokeObjectURL(oldSrc);
}


/***/ }),
/* 13 */
/***/ (function(module, exports) {


/**
 * When source maps are enabled, `style-loader` uses a link element with a data-uri to
 * embed the css on the page. This breaks all relative urls because now they are relative to a
 * bundle instead of the current page.
 *
 * One solution is to only use full urls, but that may be impossible.
 *
 * Instead, this function "fixes" the relative urls to be absolute according to the current page location.
 *
 * A rudimentary test suite is located at `test/fixUrls.js` and can be run via the `npm test` command.
 *
 */

module.exports = function (css) {
  // get current location
  var location = typeof window !== "undefined" && window.location;

  if (!location) {
    throw new Error("fixUrls requires window.location");
  }

	// blank or null?
	if (!css || typeof css !== "string") {
	  return css;
  }

  var baseUrl = location.protocol + "//" + location.host;
  var currentDir = baseUrl + location.pathname.replace(/\/[^\/]*$/, "/");

	// convert each url(...)
	/*
	This regular expression is just a way to recursively match brackets within
	a string.

	 /url\s*\(  = Match on the word "url" with any whitespace after it and then a parens
	   (  = Start a capturing group
	     (?:  = Start a non-capturing group
	         [^)(]  = Match anything that isn't a parentheses
	         |  = OR
	         \(  = Match a start parentheses
	             (?:  = Start another non-capturing groups
	                 [^)(]+  = Match anything that isn't a parentheses
	                 |  = OR
	                 \(  = Match a start parentheses
	                     [^)(]*  = Match anything that isn't a parentheses
	                 \)  = Match a end parentheses
	             )  = End Group
              *\) = Match anything and then a close parens
          )  = Close non-capturing group
          *  = Match anything
       )  = Close capturing group
	 \)  = Match a close parens

	 /gi  = Get all matches, not the first.  Be case insensitive.
	 */
	var fixedCss = css.replace(/url\s*\(((?:[^)(]|\((?:[^)(]+|\([^)(]*\))*\))*)\)/gi, function(fullMatch, origUrl) {
		// strip quotes (if they exist)
		var unquotedOrigUrl = origUrl
			.trim()
			.replace(/^"(.*)"$/, function(o, $1){ return $1; })
			.replace(/^'(.*)'$/, function(o, $1){ return $1; });

		// already a full url? no change
		if (/^(#|data:|http:\/\/|https:\/\/|file:\/\/\/)/i.test(unquotedOrigUrl)) {
		  return fullMatch;
		}

		// convert the url to a full url
		var newUrl;

		if (unquotedOrigUrl.indexOf("//") === 0) {
		  	//TODO: should we add protocol?
			newUrl = unquotedOrigUrl;
		} else if (unquotedOrigUrl.indexOf("/") === 0) {
			// path should be relative to the base url
			newUrl = baseUrl + unquotedOrigUrl; // already starts with '/'
		} else {
			// path should be relative to current directory
			newUrl = currentDir + unquotedOrigUrl.replace(/^\.\//, ""); // Strip leading './'
		}

		// send back the fixed url(...)
		return "url(" + JSON.stringify(newUrl) + ")";
	});

	// send back the fixed css
	return fixedCss;
};


/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(10);
if(typeof content === 'string') content = [[module.i, content, '']];
// Prepare cssTransformation
var transform;

var options = {}
options.transform = transform
// add the styles to the DOM
var update = __webpack_require__(12)(content, options);
if(content.locals) module.exports = content.locals;
// Hot Module Replacement
if(false) {
	// When the styles change, update the <style> tags
	if(!content.locals) {
		module.hot.accept("!!../../../../../node_modules/css-loader/index.js!./res.css", function() {
			var newContent = require("!!../../../../../node_modules/css-loader/index.js!./res.css");
			if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
			update(newContent);
		});
	}
	// When the module is disposed, remove the <style> tags
	module.hot.dispose(function() { update(); });
}

/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const redux_1 = __webpack_require__(3);
const react_redux_1 = __webpack_require__(2);
const react_fela_1 = __webpack_require__(1);
const client_layout_redux_1 = __webpack_require__(5);
const options = [
    {
        label: 'Problems',
        value: 'problems',
    },
    {
        label: 'Output',
        value: 'output',
    },
    {
        label: 'Debug console',
        value: 'debug',
    },
    {
        label: 'Terminal',
        value: 'terminal',
    },
];
const Option = redux_1.compose(...[
    react_redux_1.connect((state, { name }) => ({
        active: state.consolePanel.active === name,
    }), dispatch => ({
        onClick: (name) => dispatch(client_layout_redux_1.setActiveConsoleTab(name)),
    })),
    react_fela_1.connect({
        option: ({ active }) => ({
            color: active ? '#e7e7e7' : '#cccccc',
            opacity: active ? 1 : .8,
            margin: '10px 14px',
            fontSize: '11px',
            userSelect: 'none',
            textTransform: 'uppercase',
            fontFamily: '-apple-system,BlinkMacSystemFont,Segoe WPC,Segoe UI,HelveticaNeue-Light,Ubuntu,Droid Sans,sans-serif',
            transition: 'color 50ms ease',
            cursor: 'pointer',
            '&:hover': {
                opacity: 1,
                color: '#e7e7e7',
            },
        }),
    }),
])(({ label, name, onClick, styles }) => (React.createElement("div", { className: styles.option, onClick: onClick.bind(this, name) }, label)));
class Controls extends React.PureComponent {
    componentDidMount() {
        if (!this.props.activeTab) {
            this.props.setActiveConsoleTab(options[0].value);
        }
    }
    renderOptions() {
        return (React.createElement("div", { className: this.props.styles.options }, options.map(option => (React.createElement("div", { key: option.value },
            React.createElement(Option, { label: option.label, name: option.value }))))));
    }
    renderHeader() {
        const { controls, activeTab } = this.props;
        if (controls && controls[activeTab] && controls[activeTab].header) {
            return controls[activeTab].header;
        }
        return null;
    }
    render() {
        return (React.createElement("div", { className: this.props.styles.container },
            this.renderOptions(),
            this.renderHeader()));
    }
}
exports.Controls = Controls;
exports.default = redux_1.compose(...[
    react_redux_1.connect(state => ({
        activeTab: state.consolePanel.active,
    }), dispatch => ({
        setActiveConsoleTab: (name) => dispatch(client_layout_redux_1.setActiveConsoleTab(name)),
    })),
    react_fela_1.connect({
        container: () => ({
            display: 'flex',
            justifyContent: 'space-between',
            flexDirection: 'row',
            height: '35px',
        }),
        options: () => ({
            display: 'flex',
        }),
    }),
])(Controls);


/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(1);
const iconStyle = {
    display: 'block',
    height: '35px',
    lineHeight: '35px',
    minWidth: '28px',
    backgroundSize: '16px!important',
    backgroundPosition: '50%!important',
    backgroundRepeat: 'no-repeat!important',
    outlineOffset: '-2px',
};
exports.IconMaximize = react_fela_1.connect({
    icon: () => (Object.assign({ background: `url("data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16'%3E%3Cstyle%3E.icon-canvas-transparent{opacity:0;fill:%232d2d30}.icon-vs-out{fill:%232d2d30}.icon-vs-bg{fill:%23c5c5c5}%3C/style%3E%3Cpath class='icon-canvas-transparent' d='M16 16H0V0h16v16z' id='canvas'/%3E%3Cpath class='icon-vs-bg' d='M14.207 10.413l-1.414 1.414-4.826-4.826-4.76 4.761-1.414-1.414 6.174-6.175 6.24 6.24z' id='iconBg'/%3E%3C/svg%3E") 50% no-repeat` }, iconStyle)),
})(({ styles, onClick }) => (React.createElement("div", { className: styles.icon, onClick: onClick })));
exports.IconMinimize = react_fela_1.connect({
    icon: () => (Object.assign({ background: `url("data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16'%3E%3Cstyle%3E.icon-canvas-transparent{opacity:0;fill:%232d2d30}.icon-vs-out{fill:%232d2d30}.icon-vs-bg{fill:%23c5c5c5}%3C/style%3E%3Cpath class='icon-canvas-transparent' d='M16 16H0V0h16v16z' id='canvas'/%3E%3Cpath class='icon-vs-bg' d='M7.967 11.827L1.793 5.652l1.414-1.414 4.76 4.761 4.826-4.826 1.414 1.414-6.24 6.24z' id='iconBg'/%3E%3C/svg%3E") 50% no-repeat` }, iconStyle)),
})(({ styles, onClick }) => (React.createElement("div", { className: styles.icon, onClick: onClick })));


/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(1);
exports.default = react_fela_1.connect({
    panels: () => ({
        height: 'calc(100% - 35px)',
    }),
})(({ styles, children }) => (React.createElement("div", { className: styles.panels }, children)));


/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const redux_1 = __webpack_require__(3);
const react_redux_1 = __webpack_require__(2);
const react_fela_1 = __webpack_require__(1);
const react_resizable_box_1 = __webpack_require__(28);
const Controls_1 = __webpack_require__(15);
const Panels_1 = __webpack_require__(17);
const Icons_1 = __webpack_require__(16);
const resizeSides = {
    top: true,
    right: false,
    bottom: false,
    left: false,
    topRight: false,
    bottomRight: false,
    bottomLeft: false,
    topLeft: false,
};
const closeOpts = { height: 0 };
class ConsolePanelComponent extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.onResizeStop = (e, dir, el) => {
            const height = el.clientHeight;
            if (height > 100) {
                this.props.saveSize({ height });
            }
        };
        this.onResize = (e, dir, el) => {
            const height = el.clientHeight;
            this.props.onResize({ height });
        };
    }
    componentDidMount() {
        if (!this.props.height) {
            this.props.onResize({ height: 200 });
        }
    }
    renderIcon() {
        const { height } = this.props;
        if (height) {
            return React.createElement(Icons_1.IconMinimize, { onClick: this.props.onResize.bind(this, closeOpts) });
        }
        return React.createElement(Icons_1.IconMaximize, { onClick: this.props.open });
    }
    renderPanel() {
        const { activeTab, controls } = this.props;
        if (controls && controls[activeTab] && controls[activeTab].panel) {
            return controls[activeTab].panel;
        }
        return null;
    }
    render() {
        const { styles, height, controls } = this.props;
        return (React.createElement(react_resizable_box_1.default, { height: height, maxHeight: window.innerHeight - 50, enable: resizeSides, onResize: this.onResize, onResizeStop: this.onResizeStop },
            React.createElement("div", { className: styles.container },
                React.createElement("div", { className: styles.toggleIcon }, this.renderIcon()),
                React.createElement(Controls_1.default, { controls: controls }),
                React.createElement(Panels_1.default, null, this.renderPanel()))));
    }
}
exports.ConsolePanelComponent = ConsolePanelComponent;
const ConsolePanel = redux_1.compose(...[
    react_fela_1.connect({
        container: ({ backgroundColor }) => ({
            width: '100%',
            height: 'calc(100% - 0px)',
            borderTop: '2px solid rgb(49, 49, 55)',
            backgroundColor: backgroundColor || 'khaki',
        }),
        toggleIcon: () => ({
            position: 'absolute',
            top: '-35px',
            right: '0px',
            cursor: 'pointer',
        }),
    }),
    react_redux_1.connect((state) => ({
        activeTab: state.consolePanel.active,
    })),
])(ConsolePanelComponent);
exports.default = ConsolePanel;


/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(1);
class EditorPanel extends React.PureComponent {
    renderFileEditors() {
        const { openFiles } = this.props;
        return (React.createElement("div", null, openFiles.map(fileId => React.createElement("div", { key: fileId }))));
    }
    render() {
        const { openFiles, styles } = this.props;
        const hasFile = Array.isArray(openFiles) && openFiles.length;
        return (React.createElement("div", { className: styles.container }, hasFile ? this.renderFileEditors() : null));
    }
}
exports.default = react_fela_1.connect({
    container: ({ backgroundColor }) => ({
        backgroundColor: backgroundColor || 'bisque',
        width: '100%',
        height: '100%',
    }),
})(EditorPanel);


/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(1);
class Icon extends React.PureComponent {
    render() {
        const { disabled, image, style, styles, tooltip, onClick } = this.props;
        return (React.createElement("button", { disabled: disabled, className: styles.anchor, style: style, onClick: onClick }));
    }
}
exports.default = react_fela_1.connect({
    anchor: ({ active }) => ({
        display: 'flex',
        overflow: 'hidden',
        height: '40px',
        lineHeight: '40px',
        marginRight: '0',
        padding: '0 0 0 50px',
        margin: 0,
        fontSize: '15px',
        cursor: 'pointer',
        backgroundColor: active ? 'rgb(255, 255, 255)' : 'rgb(180, 180, 180)',
        '&:hover': {
            backgroundColor: 'rgb(255, 255, 255)',
        },
    }),
})(Icon);


/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(1);
const Icon_1 = __webpack_require__(20);
class IconPanel extends React.Component {
    constructor() {
        super(...arguments);
        this.onItemClick = itemId => {
            const isDblClick = itemId === this.props.activeId;
            const func = itemId === this.props.activeId
                ? this.props.onDoubleClick
                : this.props.onClick;
            if (func) {
                func(itemId);
            }
        };
    }
    componentDidMount() {
        if (this.props.icons) {
            this.onItemClick(this.props.icons[0].name);
        }
    }
    renderIcons() {
        const { icons, activeId } = this.props;
        return icons.map((icon, index) => (React.createElement(Icon_1.default, { onClick: () => this.onItemClick(icon.name), active: icon.name === activeId, style: icon.style, key: index })));
    }
    render() {
        const { hidden, style, styles } = this.props;
        if (hidden) {
            return null;
        }
        return (React.createElement("div", { className: styles.container, style: style }, this.renderIcons()));
    }
}
IconPanel.defaultProps = {
    direction: 'vertical',
    icons: [
        {
            style: {
                WebkitMask: `url("data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' width='32' height='32'%3E%3Cpath d='M17.705 8H9s-2 .078-2 2v15s0 2 2 2l11-.004C22 27 22 25 22 25V13.509L17.705 8zM16 10v5h4v10H9V10h7zm5.509-6h-8.493S11 4.016 10.985 6H19v.454L22.931 11H24v12c2 0 2-1.995 2-1.995V9.648L21.509 4z' fill='%23fff'/%3E%3C/svg%3E") no-repeat 50% 50%`
            },
            name: 'files',
        },
        {
            style: {
                WebkitMask: `url("data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' width='32' height='32'%3E%3Cpath d='M19.23 4.095c-4.842 0-8.769 3.928-8.769 8.771 0 1.781.539 3.43 1.449 4.815 0 0-5.482 5.455-7.102 7.102-1.621 1.646 1.001 4.071 2.602 2.409 1.602-1.659 7.006-7.005 7.006-7.005a8.726 8.726 0 0 0 4.814 1.45 8.773 8.773 0 0 0 8.772-8.771c.001-4.844-3.927-8.771-8.772-8.771zm0 15.035a6.265 6.265 0 1 1 0-12.529 6.264 6.264 0 1 1 0 12.529z' fill='%23fff'/%3E%3C/svg%3E") no-repeat 50% 50%`
            },
            name: 'search',
        },
    ],
};
exports.default = react_fela_1.connect({
    container: ({ direction }) => ({
        display: 'flex',
        width: '50px',
        paddingTop: '12px',
        flexDirection: direction === 'horizontal' ? 'row' : 'column',
        backgroundColor: 'rgb(38, 38, 38)',
    }),
})(IconPanel);


/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(1);
const react_resizable_1 = __webpack_require__(27);
__webpack_require__(14);
class TreePanel extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.onResizeStop = (e, { size: { width } }) => {
            if (width <= window.innerWidth * 0.8 && width >= 150) {
                this.props.saveSize({ width });
            }
        };
        this.onResize = (e, { size: { width } }) => {
            if (width <= window.innerWidth * 0.8 && width >= 150) {
                this.resizeWidth(width);
            }
            else if (width < 100) {
                this.resizeWidth(0);
            }
        };
        this.resizeWidth = width => {
            this.props.onResize({ width });
        };
    }
    render() {
        const { styles, width } = this.props;
        return (React.createElement(react_resizable_1.Resizable, { id: 'sidePanel', axis: 'x', width: width, height: Infinity, onResize: this.onResize, onResizeStop: this.onResizeStop },
            React.createElement("div", { className: styles.container, style: { width } })));
    }
}
exports.default = react_fela_1.connect({
    container: ({ backgroundColor }) => ({
        height: '100%',
        backgroundColor: backgroundColor || 'pink',
    }),
})(TreePanel);


/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(2);
const components_1 = __webpack_require__(4);
const client_layout_redux_1 = __webpack_require__(5);
const mapStateToProps = state => ({
    activeId: state.sideMenu.active,
});
const mapDispatchToProps = dispatch => ({
    onClick: itemId => dispatch(client_layout_redux_1.setActiveSideMenu(itemId)),
    onDoubleClick: () => dispatch(client_layout_redux_1.setInactiveSideMenu()),
});
const IconPanelEnhanced = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(components_1.IconPanel);
exports.default = IconPanelEnhanced;


/***/ }),
/* 24 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const redux_1 = __webpack_require__(3);
const react_redux_1 = __webpack_require__(2);
const react_fela_1 = __webpack_require__(1);
const EditorPanel_1 = __webpack_require__(8);
const ConsolePanel_1 = __webpack_require__(7);
const RightLayout = (props) => (React.createElement("div", { className: props.styles && props.styles.container },
    React.createElement(EditorPanel_1.default, null),
    React.createElement(ConsolePanel_1.default, { controls: props.controls })));
exports.default = redux_1.compose(...[
    react_redux_1.connect(state => ({
        treePanelWidth: state.resize.treePanel || 0,
    })),
    react_fela_1.connect({
        container: ({ treePanelWidth }) => ({
            height: '100%',
            width: `calc(100vw - ${treePanelWidth}px - 50px)`,
            overflowY: 'scroll',
            display: 'flex',
            flexDirection: 'column',
            justifyContent: 'space-between',
        }),
    }),
])(RightLayout);


/***/ }),
/* 25 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const redux_1 = __webpack_require__(3);
const react_redux_1 = __webpack_require__(2);
const client_layout_redux_1 = __webpack_require__(5);
const components_1 = __webpack_require__(4);
const hoc_1 = __webpack_require__(6);
const TreePanelEnhanced = redux_1.compose(react_redux_1.connect(state => ({
    activeId: state.sideMenu.active,
    width: state.resize.treePanel || 0,
}), dispatch => ({
    onResize: ({ width }) => {
        dispatch(client_layout_redux_1.resizeTreePanel(width));
    },
    saveSize: ({ width }) => {
        dispatch(client_layout_redux_1.resize('treePanelPrev', width));
    },
})), hoc_1.withTheme({
    backgroundPrimary: 'backgroundColor',
}))(components_1.TreePanel);
exports.default = TreePanelEnhanced;


/***/ }),
/* 26 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(4));
__export(__webpack_require__(9));


/***/ }),
/* 27 */
/***/ (function(module, exports) {

module.exports = require("react-resizable");

/***/ }),
/* 28 */
/***/ (function(module, exports) {

module.exports = require("react-resizable-box");

/***/ })
/******/ ]);
//# sourceMappingURL=index.js.map